require("../css/index.less");
const $ = require('jquery');
require('jquery-templates');
const md5 = require('js-md5');
require("./modal.js")
const {api,post,pageMap,delCookie} = require('./utils.js');

$(function(){
  getMenu();
  //菜单展开收起
  sureChangeWord()
  $(".main").css({
    height:$(window).height()-70+'px'
  })
});

function initMenu(data,userInfo){
  //菜单数据填充
  $("#menuTmpl").tmpl(data).appendTo(".menu ul");
  //用户数据填充
  $("#userName").text(userInfo.linkman);
  //菜单收起展开
  $(".list-1").on("click",function(){
    $(".list-1 .slide-up").removeClass('slide-up');
    $(this).toggleClass('slide-up');
    $(this).find("ul").slideToggle();
  });
  $(".list-1 li").on("click",function(e){
    e.stopPropagation();
  });
  //右侧页面切换
  $(".page").on("click",function(){
    $(".menu .active").removeClass('active');
    $(this).addClass("active");
    const code = $(this).attr("code");
    const url = './'+pageMap[code];
    $("#contentIframe").attr("src",url);
  });
}

function getMenu(){
  post(api.getMenu).then(function(res){
    if(res.data.code==='0'){
      const data = res.data.data;
      initMenu(data.menuWrappers,data.userLoginDTO);
    }
  });
};

function sureChangeWord(){
  $(document).on('click','.sureChange',function(){
    let oldword = $(".oldword").val().trim()
    let newword = $(".newword").val().trim()
    let sureword = $(".sureword").val().trim()
    if(!oldword){
      $(".modalAction .waring").css('display','block').find("i").html('请输入原始密码')
      return
    }else if(!newword){
      $(".modalAction .waring").css('display','block').find("i").html('请输入新密码')
      return
    }else if(!sureword){
      $(".modalAction .waring").css('display','block').find("i").html('请再次输入新密码')
      return
    }
    if(newword != sureword){
      $(".modalAction .waring").css('display','block').find("i").html('两次密码不一致')
      return
    }
    changeWord(oldword,newword)
  })
}
function changeWord(oldword,newword){
  post(api.midifyPassword,{
    "modifyPassword": md5(newword),
    "password": md5(oldword)
  }).then(function(res){
    const data = res.data;
    if(data.code==='0'){
      window.location.href = './login.html'
    }else{
      $(".modalAction .waring").css('display','block').find("i").html(data.msg)
      return
    }
  });
}
//用户信息下拉事件
$(".setting").click(function(){
  $(".userAction").slideToggle();
})
//点击修改密码
$(".container").on('click','#changeWord',function(){
  const status = $(".modalAction").css("display")
  $.alerModal({
    title:"修改密码",
    type:"modal",
    width:'450',
    time:'1000',
    sureText:'保存',
    message:`
    <div class="modalAction">
      <p><span>原密码：</span><input type="text" placeholder="请输入原密码" class="oldword" autocomplete="off"></p>
      <p><span>新密码：</span><input type="text" placeholder="请输入新密码" class="newword" autocomplete="off"></p>
      <p><span>确认新密码：</span><input type="text" placeholder="请输入新密码" class="sureword" autocomplete="off"></p>
      <p class="waring"><span></span><i></i></p>
    </div>
  `});
  $(".userAction").hide();
})
//推出登录
$(".login-out").click(function(){
  delCookie('accessToken')
})