const $ = require('jquery');
require("../css/itemManager.less");
require('./../resource/jquery-ui/jquery-ui.min.js');
const {api} = require('./api.js')
const {post} = require('./utils.js')
const switchIconOpen = require("./../images/btn_open.png")
const switchIconClose = require("./../images/btn_close.png")
const iconDown= require("./../images/arrow_down.png")
const iconUp = require("./../images/arrow_up.png")
const arrowLeft= require("./../images/arrow_left.png")
const arrowRight = require("./../images/arrow_right.png")
let casesId="", name="", isReject ="", isUsed =""
$(".selectModuleType").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
$(".selectReject").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
$(".selectUsed").append(`<img class="arrow" src=${iconDown} alt="下拉">`)

//获取表格数据
function getTabData(activePage){
    const param = {
        current:activePage,
        casesId: casesId,
        name: name, //条目名
        isReject: isReject, //1-单项否决 0-非
        isUsed: isUsed //0-未启用 1-启用
    }
    post(api.getQcCasesEntryAll,param).then(res =>{
        if(res.data.code == '0'){
            const data = res.data.data.records
            const totalPage = res.data.data.pages
            const totalNum = res.data.data.total
            renderTab(data,activePage)
            if(totalPage > 1){
                renderPagination(totalPage,activePage,totalNum)
            } else{
                $('.pagination').html("")
            }

        }else{}
    }).catch((e) =>{
    
    })
}
$(".moduleItemInp").on("input", function(e){
    const val = $(this).val().trim()
    name = val
})
$(".filter").on("click", function(e){
    getTabData(1)
})
$('.selectModuleType').on("click", function(e){
    e.stopPropagation()
    $(".rejectList ").css("display","none")
    $(".usedList ").css("display", "none")
    $(".selectReject .arrow").attr("src",iconDown)
    $(".selectUsed .arrow").attr("src",iconDown)
    const showList =  $(".moduleTypeList ").css("display")
    if(showList == "none" ||!showList){
        $(".moduleTypeList ").css("display","block")
        $(".selectModuleType .arrow").attr("src",iconUp)
    }else{
        $(".moduleTypeList ").css("display", "none")
        $(".selectModuleType .arrow").attr("src",iconDown)
    }
})
    
$('.selectReject').on("click", function(e){
    e.stopPropagation()
    $(".moduleTypeList ").css("display", "none")
    $(".usedList ").css("display", "none")
    $(".selectModuleType .arrow").attr("src",iconDown)
    $(".selectUsed .arrow").attr("src",iconDown)
    const showList =  $(".rejectList ").css("display")
    if(showList == "none" ||!showList){
        $(".rejectList ").css("display","block")
        $(".selectUsed .arrow").attr("src",iconUp)
    }else{
        $(".rejectList ").css("display", "none")
        $(".selectUsed .arrow").attr("src",iconDown)
    }
})
$('.selectUsed').on("click", function(e){
    e.stopPropagation()
    $(".moduleTypeList ").css("display", "none")
    $(".rejectList ").css("display","none")
    $(".selectModuleType .arrow").attr("src",iconDown)
    $(".selectReject .arrow").attr("src",iconDown)
    const showList =  $(".usedList ").css("display")
    if(showList == "none" ||!showList){
        $(".usedList ").css("display","block")
        $(".selectUsed .arrow").attr("src",iconUp)
    }else{
        $(".usedList ").css("display", "none")
        $(".selectUsed .arrow").attr("src",iconDown)
    }
})
bindRejectSelect()
bindUsedSelect()
getTabData(1)
getmoduleTypeList()
function renderTab(data,activePage){
    let str = ``
    for(let i = 0; i < data.length; i++){
        const item = data[i]
        str += `
            <tr data-id=${item.id} data-index=${i}>
                <td  class="textCenter">${(activePage-1)*10 + i+1}</td>
                <td>${item.casesName}</td>
                <td>${item.name}</td>
                <td>${item.msg}</td>
                <td  class="textCenter">${item.score}</td>
                <td  class="textCenter">${item.isReject == '1' ? `<img class="switchImg" src=${switchIconOpen} />`:`<img class="switchImg" src=${switchIconClose} />`}</td>
                <td class="textCenter">${item.isUsed == '1' ? `<img class="switchImg" src=${switchIconOpen} />`:`<img class="switchImg" src=${switchIconClose} />`}</td>
                <td class="editItem">修改</td>
            </tr>
        `
    }
    $('tbody').html(str)
    bindEdit(data,activePage)
}

function bindEdit(data,activePage){
    $('.editItem').click(function(e){
        const index = $(this).parent().attr('data-index') 
        editItem(data[index],activePage)
    })
}

//修改
function editItem(item,activePage){
    const itemCpoy = JSON.parse(JSON.stringify(item))
    $('.pop-box').remove()
    $('.container').append('<div class="pop-box"></div>')
    const str = `
        <div class="itemMsgBox">
            <div class="mask"></div>
            <div class="itemMsgContent">
                <p class="itemMsgTitle">修改 <img class="iconClose" src=${require('./../images/icon_close_default.png')} alt="关闭" /></p>
                <div class="itemMsgContentBox">
                    <div class="itemMsgInfoBox"><span class="itemMsgLab">模块类别：</span> <span class="itemInfoRight">${itemCpoy.casesName}</span></div>
                    <div class="itemMsgInfoBox"><span class="itemMsgLab">质控条目名称：</span> <span class="itemInfoRight"> ${itemCpoy.name}</span></div>
                    <div class="itemMsgInfoBox"><span class="itemMsgLab">提示信息：</span> <span class="itemInfoRight"> <input class="itemTipMsg" value=${itemCpoy.msg} /></span></div>
                    <div class="itemMsgInfoBox"><span class="itemMsgLab">分值：</span> <span class="itemInfoRight"> <input class="itemScore"  type="number" value=${itemCpoy.score} /></span></div>
                    <div class="itemMsgInfoBox"><span class="itemMsgLab">单项否决：</span><span class="itemInfoRight itemReject">${item.isReject == '1' ? `<img class="switchImg" src=${switchIconOpen} />`:`<img class="switchImg" src=${switchIconClose} />`}</span></div>
                    <div class="itemMsgInfoBox"><span class="itemMsgLab">启用：</span><span class=" temInfoRight itemUsed">${item.isUsed == '1' ? `<img class="switchImg" src=${switchIconOpen} />`:`<img class="switchImg" src=${switchIconClose} />`}</span></div>
                </div>
                
                <div class="confirmEditBox"><span class="confirmEdit">保存</span></div>
            </div>
        </div>
       
    `
    $("#mainBox", parent.document).append(str)
    $("#mainBox .itemMsgBox .iconClose", parent.document).on("click", function(e){
        $("#mainBox .itemMsgBox", parent.document).remove()
    })
    $("#mainBox .itemMsgBox .itemTipMsg", parent.document).on("input", function(e){
        const val = $(this).val()
        itemCpoy.msg = val
    })
    $("#mainBox .itemMsgBox .itemScore", parent.document).on("input", function(e){
        const val = $(this).val()
        itemCpoy.score = val
    })
    $("#mainBox .itemMsgBox .itemReject", parent.document).on("click", function(e){
        itemCpoy.isReject = itemCpoy.isReject == 1 ? 0 : 1
        $('#mainBox .itemMsgBox', parent.document).remove()
        editItem(itemCpoy,activePage)
    })
    $("#mainBox .itemMsgBox .itemUsed", parent.document).on("click", function(e){
        itemCpoy.isUsed = itemCpoy.isUsed == 1 ? 0 : 1
        $('#mainBox .itemMsgBox', parent.document).remove()
        editItem(itemCpoy,activePage)
    })
    
    $("#mainBox .itemMsgBox .confirmEdit", parent.document).on("click", function(){
        saveEdit(itemCpoy,activePage)
        $('#mainBox .itemMsgBox', parent.document).remove()
    })
   
    
}

//保存修改
function saveEdit(item,activePage){
    const param = {
        id: item.id,
        isReject: item.isReject,
        isUsed: item.isUsed,
        msg: item.msg,
        score: item.score
    }

    post(api.updataQcCasesEntry,param).then(res =>{
        if(res.data.code == '0'){
            const data = res.data.data
            getTabData(activePage)
        }else{}
    }).catch((e) =>{
    
    })
}

//获取模块类型
function getmoduleTypeList(){
    post(api.getQcCasesAll).then(res =>{
        if(res.data.code == '0'){
           const  moduleTypeList = res.data.data
           renderModuleTypeList(moduleTypeList)
        }else{}
    }).catch((e) =>{
    
    })
}


function renderModuleTypeList(moduleTypeList){
    let str = `<li class="modeTypeItem " data-id=" " data-name="全部">全部</li>`
    for(let i = 0; i < moduleTypeList.length; i++){
        str += `<li class="modeTypeItem ellipsis" title=${moduleTypeList[i].name} data-id=${moduleTypeList[i].id} data-name=${moduleTypeList[i].name}> ${moduleTypeList[i].name}</li>`
    }
    $('.moduleTypeList').html(str)
    bindModuleTypeSelect()
}

//模块类型选择
function bindModuleTypeSelect(){
    $('.modeTypeItem').on("click",function(){
        const modeTypeItemName = $(this).attr("data-name")
        const modeTypeItemId = $(this).attr("data-id")
        casesId=modeTypeItemId
        $('.selectModuleType').html(modeTypeItemName)
        $(".moduleTypeList ").css("display", "none")
    })
}
//单项否决选择
function bindRejectSelect(){
    $('.rejectItem').on("click",function(){
        const rejectItemName = $(this).attr("data-name")
        const rejectItemId = $(this).attr("data-id")
        isReject=rejectItemId
        $('.selectReject').html(rejectItemName)
        $(".rejectList ").css("display", "none")
    })
}
//是否启用选择
function bindUsedSelect(){
    $('.usedItem').on("click",function(){
        const usedItemName = $(this).attr("data-name")
        const usedItemItemId = $(this).attr("data-id")
        isUsed=usedItemItemId
        $('.selectUsed').html(usedItemName)
        $(".usedList").css("display", "none")
    })
}




//分页渲染
function renderPagination(totalPage,activePage,totalNum){
    let str = `<span class="totalSum">共${totalPage}页/${totalNum}条数据</span><span class="prePage"><img class="arrowPage" src=${arrowLeft} /></span>`
    if(totalPage <= 6){
        for(let i = 1; i <= totalPage; i++){
            str += `<span class="pageNum ${'page'+i}" data-page=${i}>${i}</span>`
        }
    }else{
        if(activePage <= 3){ //选中页数小于4
            for(let i = 1; i <= 4; i++){
                str += `<span class="pageNum ${'page'+i}" data-page=${i}>${i}</span>`
            }
            str += `<span class="more" >...</span>`
        str += `<span class="pageNum ${'page'+totalPage}" data-page=${totalPage}>${totalPage}</span>`

        } else if(activePage > totalPage -3){
            str += `<span class="pageNum page1" data-page=1>1</span>`
            str += `<span class="more" >...</span>`
            str += `<span class="pageNum ${'page'+(totalPage-3)}" data-page=${totalPage -3}>${totalPage -3}</span>`
            str += `<span class="pageNum ${'page'+(totalPage-2)}" data-page=${totalPage -2}>${totalPage -2}</span>`
            str += `<span class="pageNum ${'page'+(totalPage-1)}" data-page=${totalPage -1}>${totalPage -1}</span>`
            str += `<span class="pageNum ${'page'+totalPage}" data-page=${totalPage}>${totalPage}</span>`
        } else {
            str += `<span class="pageNum page1" data-page=1>1</span>`
            str += `<span class="more" >...</span>`
            str += `<span class="pageNum ${'page'+(activePage -1)}" data-page=${activePage -1}>${activePage -1}</span>`
            str += `<span class="pageNum ${'page'+activePage}" data-page=${activePage}>${activePage}</span>`
            str += `<span class="pageNum ${'page'+(activePage +1)}" data-page=${activePage +1}>${activePage +1}</span>`
            str += `<span class="more" >...</span>`
            str += `<span class="pageNum ${'page'+totalPage}" data-page=${totalPage}>${totalPage}</span>`
        }
       
    }
    str += `<span class="nextPage"><img class="arrowPage" src=${arrowRight} /></span>`
    $('.pagination').html(str)
    $('.page' + activePage).addClass('activePage')
    $(".pageNum").on("click", function(e){
        const activePageNow = Number($(this).attr('data-page'))
        getTabData(activePageNow)
        // renderPagination(totalPage,activePageNow,totalNum)
    })
    $(".prePage").on("click", function(e){
        let activePageNow = Number($(".activePage").attr('data-page'))
        if(activePageNow > 1){
            activePageNow--
            getTabData(activePageNow)
            // renderPagination(totalPage,activePageNow,totalNum)
        }
    })
    $(".nextPage").on("click", function(e){
        let activePageNow = Number($(".activePage").attr('data-page'))
        if(activePageNow < totalPage){
            activePageNow++
            getTabData(activePageNow)
            // renderPagination(totalPage,activePageNow,totalNum)
        }
    })
    
}

$(document).on("click", function(){
    $(".moduleTypeList ").css("display", "none")
    $(".rejectList ").css("display","none")
    $(".usedList ").css("display", "none")
    $(".selectModuleType .arrow").attr("src",iconDown)
    $(".selectReject .arrow").attr("src",iconDown)
    $(".selectUsed .arrow").attr("src",iconDown)
})