const qs = require('qs');
const $ = require("jquery");
var Utils = require('./rePromise');

//页面映射
const pageMap={
  'YH-KZT':'console.html',
  'YH-JCSJWH-MKSJWH':'moduleManager.html',
  'YH-JCSJWH-TMSJWH':'itemManager.html',
  'YH-BLZK-ZKPF':'qcList.html',
  'YH-TJFX':'statistics.html',
};
const api={
  getMenu:'/sys/user/getUserOrgMenu',     //获取菜单
  midifyPassword:'/sys/user/midifyPassword',     //修改密码
  getSubMenu:'/qc/mode/getMenu',   //获取质控评分菜单
  delScore:'/qc/behospitalInfo/delCase' ,//删除评分项
  editScore:'/qc/behospitalInfo/updCase' ,//修改评分
  addScore:'/qc/behospitalInfo/addCase' ,//添加评分项
  getRecordDetail:'/qc/behospitalInfo/getByBehospitalCode', //获取病例明细
};

//重写assign方法
if (typeof Object.assign != 'function') {
  Object.assign = function (target) {
    'use strict';
    if (target == null) {
      throw new TypeError('Cannot convert undefined or null to object');
    }

    target = Object(target);
    for (var index = 1; index < arguments.length; index++) {
      var source = arguments[index];
      if (source != null) {
        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }
    }
    return target;
  };
}

window.console = window.console || (function () {
  var c = {}; c.log = c.warn = c.debug = c.info = c.error = c.time = c.dir = c.profile
    = c.clear = c.exception = c.trace = c.assert = function () { };
  return c;
})();

const getUrlArgObject = function getQueryString(name) {
  var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
  var reg_rewrite = new RegExp("(^|/)" + name + "/([^/]*)(/|$)", "i");
  var r = window.location.search.substr(1).match(reg);
  var q = window.location.pathname.substr(1).match(reg_rewrite);
  if (r != null) {
    return decodeURIComponent(r[2]);
  } else if (q != null) {
    return decodeURIComponent(q[2]);
  } else {
    return null;
  }
}

const post = function (url, data) {
  const token = getCookie('accessToken')
  return new Utils((resolve, reject) => {
    $.ajax({
      method: 'post',
      url: url,
      data: JSON.stringify(data),
      contentType: "application/json; charset=UTF-8",
      beforeSend: function (xmlHttp) {
        xmlHttp.setRequestHeader("If-Modified-Since", "0");
        xmlHttp.setRequestHeader("Cache-Control", "no-cache");
        xmlHttp.setRequestHeader("Authorization",token?"Bearer "+token:'')
      },
      success: function (res) {
        resolve({ data: res });
      },
      error: function (error) {
        reject(error);
      },
    });
  });
}

//判断浏览器是否为Ie8
const isIe8 = function () {
  var DEFAULT_VERSION = 8.0;
  var ua = navigator.userAgent.toLowerCase();
  var isIE = ua.indexOf("msie") > -1;
  var safariVersion;
  if (isIE) {
    safariVersion = ua.match(/msie ([\d.]+)/)[1];
  }
  if (safariVersion <= DEFAULT_VERSION) {
    return true
  }
}
const setCookie = function(name,value){
  let Days = 30;
  let exp = new Date();
  exp.setTime(exp.getTime() + Days*24*60*60*1000);
  document.cookie = name + "="+ escape (value) + ";expires=" + exp.toGMTString();
}

//读取cookies
const getCookie =function(name){
  let arr,reg=new RegExp("(^| )"+name+"=([^;]*)(;|$)");
  if(arr=document.cookie.match(reg))
      return unescape(arr[2]);
  else
      return null;
}

//删除cookies
const delCookie = function(name){
  let exp = new Date();
  exp.setTime(exp.getTime() - 1);
  let cval=getCookie(name);
  if(cval!=null)
      document.cookie= name + "="+cval+";expires="+exp.toGMTString();
};

//弹窗关闭事件
$(".modal .close").click(function(){
  $(".modal").hide();
});
//计算容器高度
function setBoxHeight(){
  const ht=window.innerHeight;
  $(".main-part").height((ht-60)+'px');
  $(".content-ht").height((ht-126)+"px");
}
setBoxHeight();
$(window).resize(function(){
  setBoxHeight();
});

const keyMaps = {
  "本人姓名":"姓名",
  "职业":"职业",
  "性别":"性别",
  "床号":"工作单位",
  "生日":"出生日期",
  "地址":"户口地址",
  "婚姻状况":"婚姻",
  "本人电话":"电话",
  "出生地址":"出生地",
  "入病房时间":"入病房时间",
  "民族":"民族",
  //"":"病史陈述者",
  "主诉":"主诉",
  "现病史":"现病史",
  "一般健康状况":"一般健康状况",
  "内科疾病史(其它)":"内科疾病史",
  "手术外伤史":"手术外伤史",
  "输血史":"输血史",
  "药物食物中毒史":"药物、食物中毒史",
  "传染病史":"传染病史",
  "长期用药":"长期用药情况(包括可能成瘾的药物)",
  "抗凝药物情况":"最近一周使用抗凝药物情况",
  "过敏史":"过敏史（包括食物和药物）",
  "个人史":"个人史",
  "出生、生长史":"出生、生长史",
  "冶游史":"冶游史",
  "化学及放射性毒物接触史":"化学或放射性毒物接触史",
  "个人史":"个人习惯史",
  "婚姻、月经及生育史":"婚姻史",
  "婚姻状况":"婚姻状况",
  "结婚年龄":"结婚年龄",
  "婚姻家庭关系和睦":"婚姻家庭关系和睦",
  "子女健康状况":"子女健康状况",
  "配偶健康状况":"配偶健康状况",
  "家族史":"家族史",
  "家庭成员类似病史":"家庭成员类似病史",
  "家庭成员健康情况":"家庭成员健康、疾病及死亡情况",
  "传染病史":"两系三代内传染性疾病、遗传性疾病或遗传",
  //"":"倾向性疾病",
  //"":"体格检查",
  "生命体征":"生命体征",
  "一般情况":"一般情况",
  "专科检查":"专科检查",
  "辅助检查结果":"辅助检查",
  "实验室检查":"实验室检查",
  "影像学检查":"影像学检查",
  "初步诊断":"初步诊断",
  "修正诊断":"修正诊断",
  "补充诊断":"补充诊断",
  //"":"记录医师",
  "记录日期":"记录日期及时间",
  /*"":"",
  "":"",
  "":"",
  "":"",
  "":"",
  "":"",
  "":"",
  "":"",
  "":"",
  "":"",
  "":"",
  "":"",
  "":"",
  "":"",
  "":"",
  "":"",
  "":"",
  "":"",
  "":"",
  "":"",*/
};

module.exports = {
  pageMap,
  api,
  post,
  getUrlArgObject,
  isIe8,
  setCookie,
  getCookie,
  delCookie,
  setBoxHeight,
  keyMaps
};
